<template>
  <div>
    <!-- form base customer -->
    <el-form ref="defaultForm" :model="customer" :rules="rules">
      <el-form-item prop="fullName">
        <el-tooltip content="Nombre" placement="left">
          <el-input placeholder="Nombre" v-model.trim="customer.fullName" clearable></el-input>
        </el-tooltip>
      </el-form-item>
      <el-form-item prop="email">
        <el-tooltip content="Correo" placement="left">
          <el-input placeholder="Correo" v-model.trim="customer.email" clearable></el-input>
        </el-tooltip>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="onSubmit()">{{submitLabel}}</el-button>
        <el-button v-if="!!cancelLabel" @click="onCancel()">{{cancelLabel}}</el-button>
      </el-form-item>
    </el-form>
    <!-- addresses table -->
    <div>
      <div style="text-align: center;" class="text-container">
        <span>Direcciones</span>
      </div>
      <el-table v-loading="loading" :data="addresses" stripe border style="width: 100%">
        <el-table-column prop="country" label="País" width="180" sortable></el-table-column>
        <el-table-column prop="subdivision" label="Subdivisión" width="180" sortable></el-table-column>
        <el-table-column prop="city" label="Ciudad" width="180" sortable></el-table-column>
        <el-table-column prop="postalCode" label="Cod. Postal" width="180" sortable></el-table-column>
        <el-table-column prop="shortAddress" label="Dirección" width="180" sortable></el-table-column>
        <el-table-column width="70" align="center">
          <template slot-scope="scope">
            <el-popconfirm
              placement="left"
              confirmButtonText="Si"
              cancelButtonText="No"
              icon="el-icon-info"
              iconColor="red"
              :title="`Eliminar ${scope.row.shortAddress}?`"
              @onConfirm="deleteAddress(scope.row)"
            >
              <el-button circle slot="reference" type="danger" icon="el-icon-delete"></el-button>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>
      <div class="button-container">
        <el-button type="primary" @click="onCreateAddress">Crear Dirección</el-button>
      </div>
    </div>
    <!-- contacts table -->
    <div>
      <div style="text-align: center;" class="text-container">
        <span>Contactos</span>
      </div>
      <el-table v-loading="loading" :data="contacts" stripe border style="width: 100%">
        <el-table-column prop="fullName" label="Nombre" width="180" sortable></el-table-column>
        <el-table-column prop="phone" label="Teléfono" width="180" sortable></el-table-column>
        <el-table-column prop="extension" label="Ext." width="180" sortable></el-table-column>
        <el-table-column prop="mobile" label="Celular" width="180" sortable></el-table-column>
        <el-table-column prop="email" label="Correo" width="180" sortable></el-table-column>
        <el-table-column width="70" align="center">
          <template slot-scope="scope">
            <el-popconfirm
              placement="left"
              confirmButtonText="Si"
              cancelButtonText="No"
              icon="el-icon-info"
              iconColor="red"
              :title="`Eliminar ${scope.row.fullName}?`"
              @onConfirm="deleteContact(scope.row)"
            >
              <el-button circle slot="reference" type="danger" icon="el-icon-delete"></el-button>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>
      <div class="button-container">
        <el-button type="primary" @click="onCreateContact">Crear Contacto</el-button>
      </div>
    </div>
    <!-- phones table -->
    <div>
      <div style="text-align: center;" class="text-container">
        <span>Teléfonos</span>
      </div>
      <el-table v-loading="loading" :data="phones" stripe border style="width: 100%">
        <el-table-column prop="countryCode" label="Cod. Ciudad" width="180" sortable></el-table-column>
        <el-table-column prop="subdivisionCode" label="Cod. Subdivisión" width="180" sortable></el-table-column>
        <el-table-column prop="phoneNumber" label="Teléfono" width="180" sortable></el-table-column>
        <el-table-column prop="extension" label="Ext." width="180" sortable></el-table-column>
        <el-table-column width="70" align="center">
          <template slot-scope="scope">
            <el-popconfirm
              placement="left"
              confirmButtonText="Si"
              cancelButtonText="No"
              icon="el-icon-info"
              iconColor="red"
              :title="`Eliminar ${scope.row.phoneNumber}?`"
              @onConfirm="deletePhone(scope.row)"
            >
              <el-button circle slot="reference" type="danger" icon="el-icon-delete"></el-button>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>
      <div class="button-container">
        <el-button type="primary" @click="onCreatePhone">Crear Teléfono</el-button>
      </div>
    </div>
    <!-- dialog form addressCustomer -->
    <el-dialog title="Crear Dirección" width="50%" :visible.sync="dialogAddress" center append-to-body>
      <el-form ref="addressForm" :model="addressForm" :rules="rules">
        <el-form-item prop="country">
          <el-tooltip content="País" placement="left">
            <el-input placeholder="País" v-model.trim="addressForm.country" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="subdivision">
          <el-tooltip content="Subdivisión" placement="left">
            <el-input placeholder="Subdivisión" v-model.trim="addressForm.subdivision" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="city">
          <el-tooltip content="Ciudad" placement="left">
            <el-input placeholder="Ciudad" v-model.trim="addressForm.city" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="postalCode">
          <el-tooltip content="Cod. Postal" placement="left">
            <el-input placeholder="Cod. Postal" v-model.trim="addressForm.postalCode" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="shortAddress">
          <el-tooltip content="Dirección" placement="left">
            <el-input placeholder="Dirección" v-model.trim="addressForm.shortAddress" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="createAddress('addressForm')">Crear</el-button>
          <el-button @click="dialogAddress = false">Cancelar</el-button>
        </el-form-item>
      </el-form>
    </el-dialog>
    <!-- dialog form contactCustomer -->
    <el-dialog title="Crear Contacto" width="50%" :visible.sync="dialogContact" center append-to-body>
      <el-form ref="contactForm" :model="contactForm" :rules="rules2">
        <el-form-item prop="fullName">
          <el-tooltip content="Nombre" placement="left">
            <el-input placeholder="Nombre" v-model.trim="contactForm.fullName" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="phone">
          <el-tooltip content="Teléfono" placement="left">
            <el-input placeholder="Teléfono" v-model.trim="contactForm.phone" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="extension">
          <el-tooltip content="Ext." placement="left">
            <el-input placeholder="Ext." v-model.trim="contactForm.extension" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="mobile">
          <el-tooltip content="Celular" placement="left">
            <el-input placeholder="Celular" v-model.trim="contactForm.mobile" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="email">
          <el-tooltip content="Correo" placement="left">
            <el-input placeholder="Correo" v-model.trim="contactForm.email" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="createContact('contactForm')">Crear</el-button>
          <el-button @click="dialogContact = false">Cancelar</el-button>
        </el-form-item>
      </el-form>
    </el-dialog>
    <!-- dialog form phoneCustomer -->
    <el-dialog title="Crear Teléfono" width="50%" :visible.sync="dialogPhone" center append-to-body>
      <el-form ref="phoneForm" :model="phoneForm" :rules="rules">
        <el-form-item prop="countryCode">
          <el-tooltip content="Cod. Ciudad" placement="left">
            <el-input placeholder="Cod. Ciudad" v-model.trim="phoneForm.countryCode" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="subdivisionCode">
          <el-tooltip content="Cod. Subdivisión" placement="left">
            <el-input placeholder="Cod. Subdivisión" v-model.trim="phoneForm.subdivisionCode" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="phoneNumber">
          <el-tooltip content="Teléfono" placement="left">
            <el-input placeholder="Teléfono" v-model.trim="phoneForm.phoneNumber" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item prop="extension">
          <el-tooltip content="Ext." placement="left">
            <el-input placeholder="Ext." v-model.trim="phoneForm.extension" clearable></el-input>
          </el-tooltip>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="createPhone('phoneForm')">Crear</el-button>
          <el-button @click="dialogPhone = false">Cancelar</el-button>
        </el-form-item>
      </el-form>
    </el-dialog>
  </div>
</template>

<script>
export default {
  async fetch({ store, error }) {
    console.log(initCustomer.id)
    await Promise.all(
      [
        store.dispatch('testnoova/api/customer/fetchAddresses', initCustomer.id),
        store.dispatch('testnoova/api/customer/fetchContacts', initCustomer.id),
        store.dispatch('testnoova/api/customer/fetchPhones', initCustomer.id) 
      ].map(p => p.catch(e => {
        error({ statusCode: e.response.status, message: 'Ha ocurrido un error' })
      })))
  },
  name: 'customerForm',
  props: {
    initCustomer: {
      type: Object,
      default: null
    },
    submitLabel: {
      type: String,
      required: true
    },
    cancelLabel: {
      type: String,
      default: null
    }
  },
  data() {
    return {
      selectedAddress: {},
      selectedContact: {},
      selectedPhone: {},
      customer: {
        fullName: '',
        email: ''
      },
      addressForm: {
        country: "",
        subdivision: "",
        city: "",
        postalCode: "",
        shortAddress: "",
        idCustomer: ""
      },
      contactForm: {
        fullName: "",
        phone: "",
        extension: "",
        mobile: "",
        email: "",
        idCustomer: ""
      },
      phoneForm: {
        countryCode: "",
        subdivisionCode: "",
        phoneNumber: "",
        extension: "",
        idCustomer: ""
      },
      dialogAddress: false,
      dialogContact: false,
      dialogPhone: false,
      rules: {
        fullName: [
          {
            required: true, message: "El nombre es requerido.", trigger: "blur"
          },
          {
            max: 200, message: "El nombre no puede ser mayor a 200 caracteres.", trigger: "blur"
          }
        ],
        email: [
          {
            required: true, message: "El correo es requerido.", trigger: "blur"
          },
          {
            type: "email", message: "Por favor ingrese un correo valido.", trigger: "blur"
          },
          {
            max: 150, message: "El correo no puede ser mayor a 150 caracteres.", trigger: "blur"
          }
        ],
        country: [
          {
            required: true, message: "El país es requerido.", trigger: "blur"
          },
          {
            max: 50, message: "El país no puede ser mayor a 50 caracteres.", trigger: "blur"
          }
        ],
        subdivision: [
          {
            required: true, message: "La subdivisión es requerida.", trigger: "blur"
          },
          {
            max: 50, message: "La subdivisión no puede ser mayor a 50 caracteres.", trigger: "blur"
          }
        ],
        city: [
          {
            required: true, message: "La ciudad es requerida.", trigger: "blur"
          },
          {
            max: 50, message: "La ciudad no puede ser mayor a 50 caracteres.", trigger: "blur"
          }
        ],
        postalCode: [
          {
            max: 20, message: "El código postal no puede ser mayor a 20 caracteres.", trigger: "blur"
          }
        ],
        shortAddress: [
          {
            required: true, message: "La dirección es requerida.", trigger: "blur"
          },
          {
            max: 300, message: "La dirección no puede ser mayor a 300 caracteres.", trigger: "blur"
          }
        ],
        countryCode: [
          {
            max: 5, message: "El código del país no puede ser mayor a 5 caracteres.", trigger: "blur"
          }
        ],
        subdivisionCode: [
          {
            max: 5, message: "El código de la subdivisión no puede ser mayor a 5 caracteres.", trigger: "blur"
          }
        ],
        phoneNumber: [
          {
            max: 20, message: "El número de teléfono no puede ser mayor a 20 caracteres.", trigger: "blur"
          }
        ],
        phoneNumber: [
          {
            required: true, message: "El número de teléfono es requerido.", trigger: "blur"
          },
          {
            max: 20, message: "El número de teléfono no puede ser mayor a 20 caracteres.", trigger: "blur"
          }
        ],
        extension: [
          {
            max: 50, message: "La extensión no puede ser mayor a 50 caracteres..", trigger: "blur"
          }
        ],
      },
      rules2: {
        fullName: [
          {
            required: true, message: "El nombre es requerido.", trigger: "blur"
          },
          {
            max: 200, message: "El nombre no puede ser mayor a 200 caracteres.", trigger: "blur"
          }
        ],
        phone: [
          {
            max: 20, message: "El teléfono no puede ser mayor a 20 caracteres.", trigger: "blur"
          }
        ],
        extension: [
          {
            max: 50, message: "La extensión no puede ser mayor a 50 caracteres.", trigger: "blur"
          }
        ],
        mobile: [
          {
            required: true, message: "El teléfono móvil es requerido.", trigger: "blur"
          },
          {
            max: 20, message: "El teléfono móvil no puede ser mayor a 20 caracteres.", trigger: "blur"
          }
        ],
        email: [
          {
            required: true, message: "El correo es requerido.", trigger: "blur"
          },
          {
            type: "email", message: "Por favor ingrese un correo valido.", trigger: "blur"
          },
          {
            max: 150, message: "El correo no puede ser mayor a 150 caracteres.", trigger: "blur"
          }
        ],
      }
    }
  },
  computed: {
    addresses() { return this.$store.getters['testnoova/api/customer/addresses'] },
    contacts() { return this.$store.getters['testnoova/api/customer/contacts'] },
    phones() { return this.$store.getters['testnoova/api/customer/phones'] }
  },
  watch: {
    initCustomer() {
      this.$refs['defaultForm'].resetFields()
      this.customer = this.initCustomer
    }
  },
  mounted() {
    this.callRelations(this.initCustomer.id)
  },
  created() {
    if (!!this.initCustomer) {
      this.customer = this.initCustomer
    }
  },
  methods: {
    callRelations(id) {
      this.$store
        .dispatch('testnoova/api/customer/fetchAddresses', id)
        .then(() => {});
      this.$store
        .dispatch('testnoova/api/customer/fetchContacts', id)
        .then(() => {});
      this.$store
        .dispatch('testnoova/api/customer/fetchPhones', id)
        .then(() => {});
    },
    onSubmit() {
      this.$refs['defaultForm'].validate((valid) => {
        if (valid) {
          this.$emit('submit', this.customer)
        } else {
          return false
        }
      })
    },
    onCancel() {
      this.$emit('cancel')
    },
    onCreateAddress() {
      this.dialogAddress = true 
    },
    onCreateContact() {
      this.dialogContact = true
    },
    onCreatePhone() {
      this.dialogPhone = true
    },
    createAddress(addressForm) {
      this.addressForm.idCustomer = this.customer.id
      this.$refs[addressForm].validate(valid => {
        if (valid) {
            this.$store
            .dispatch("testnoova/api/customer/saveCustomerAddress", this.addressForm)
            .then((res) => {
              console.log(res);
              this.$message({
                message: "Se ha guardado correctamente la dirección",
                type: "success"
              });
              this.$refs[addressForm].resetFields();
            })
          .catch(error => {
            if(error.response.status != 200) {
              this.$message.error(`ha ocurrido un error guardando la dirección: ${error.response.status}`);
            }
          });
        } else {
          this.$message({
            message: 'Hay errores en el formulario',
            type: 'warning'
          });
          return false;
        }
      });
    },
    createContact(contactForm) {
      this.contactForm.idCustomer = this.customer.id
      this.$refs[contactForm].validate(valid => {
        if (valid) {
            this.$store
            .dispatch("testnoova/api/customer/saveCustomerContact", this.contactForm)
            .then((res) => {
              console.log(res);
              this.$message({
                message: "Se ha guardado correctamente el contacto",
                type: "success"
              });
              this.$refs[contactForm].resetFields();
            })
          .catch(error => {
            if(error.response.status != 200) {
              this.$message.error(`ha ocurrido un error guardando el contacto: ${error.response.status}`);
            }
          });
        } else {
          this.$message({
            message: 'Hay errores en el formulario',
            type: 'warning'
          });
          return false;
        }
      });
    },
    createPhone(phoneForm) {
      this.phoneForm.idCustomer = this.customer.id
      this.$refs[phoneForm].validate(valid => {
        if (valid) {
            this.$store
            .dispatch("testnoova/api/customer/saveCustomerPhone", this.phoneForm)
            .then((res) => {
              console.log(res);
              this.$message({
                message: "Se ha guardado correctamente el teléfono",
                type: "success"
              });
              this.$refs[phoneForm].resetFields();
            })
          .catch(error => {
            if(error.response.status != 200) {
              this.$message.error(`ha ocurrido un error guardando el teléfono: ${error.response.status}`);
            }
          });
        } else {
          this.$message({
            message: 'Hay errores en el formulario',
            type: 'warning'
          });
          return false;
        }
      });
    },
    deleteAddress(address) {
      this.$store
      .dispatch("testnoova/api/customer/deleteCustomerAddress", address.id)
      .then((res) => {
        this.$message({
          message: `Dirección ${address.shortAddress} eliminada`,
          type: "success"
        });
      })
      .catch(error => {
        if(error.response.status != 200) {
          this.$message.error(`ha ocurrido un error eliminando la dirección: ${error.response.status}`);
        }
      });
    },
    deleteContact(contact) {
      this.$store
      .dispatch("testnoova/api/customer/deleteCustomerContact", contact.id)
      .then((res) => {
        this.$message({
          message: `Contacto ${contact.fullName} eliminado`,
          type: "success"
        });
      })
      .catch(error => {
        if(error.response.status != 200) {
          this.$message.error(`ha ocurrido un error eliminando el contacto: ${error.response.status}`);
        }
      });
    },
    deletePhone(phone) {
      this.$store
      .dispatch("testnoova/api/customer/deleteCustomerPhone", phone.id)
      .then((res) => {
        this.$message({
          message: `Teléfono ${phone.phoneNumber} eliminado`,
          type: "success"
        });
      })
      .catch(error => {
        if(error.response.status != 200) {
          this.$message.error(`ha ocurrido un error eliminando el telefono: ${error.response.status}`);
        }
      });
    }
  }
}
</script>

<style>
.text-container {
  padding-top: 10px;
  padding-bottom: 20px;
  font-weight: bold;
  font-size: medium;
}
.button-container {
  padding-top: 10px;
  padding-bottom: 20px;
}
</style>